<?php

namespace Teknisa\CMP\Modules\Cadastros\Services;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class cmp00100ProdutoPorFornecedorService 
{
    protected $connection;
    
    public function __construct($entityManager, $environment)
    {
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
    }
    
    public function parseFloat($floatVar)
    {
        if(is_string($floatVar)) {
            $floatVar = str_replace(".", "", $floatVar);    
            $floatVar = str_replace(",", ".", $floatVar);
        }
        
        return $floatVar;
    }
    
    /********************
     *      INSERTS     *
     ********************/
    
    public function insertProduto ($row)
    {
        $param = array();
        $param['CDFORNECED']    = $row['CDFORNECED'];
        $param['CDPRODUTO']     = $row['CDPRODUTO'];
        $param['IDTPFORPGPRF']  = /*$row['IDTPFORPGPRF']*/ null;
        $param['QTDIASENTR']    = /*$row['QTDIASENTR']*/ null;
        $param['QTMINAF']       = /*$row['QTMINAF']*/ null;
        $param['IDCOTAOBRIG']   = /*$row['IDCOTAOBRIG']*/ 'N'; 
        $param['SGUNIDADE']     = /*$row['SGUNIDADE']*/ null;
        $param['NRPARCPGTPRF']  = /*$row['NRPARCPGTPRF']*/ null;
        $param['NRDIAPGFIPRF']  = /*$row['NRDIAPGFIPRF']*/ null;
        $param['CDFORMPGTO']    = /*$row['CDFORMPGTO']*/ null;
        $param['IDUTDIAPGPRF']  = /*$row['IDUTDIAPGPRF']*/ null;
        $param['NRORG']         = $row['NRORG'];
        
        $query =    "INSERT INTO PRODFORN (
                        CDFORNECED,
                        CDPRODUTO,
                        IDTPFORPGPRF,
                        QTDIASENTR,
                        QTMINAF,
                        IDCOTAOBRIG,
                        SGUNIDADE,
                        NRPARCPGTPRF,
                        NRDIAPGFIPRF,
                        CDFORMPGTO,
                        IDUTDIAPGPRF,
                        NRORG
                    ) VALUES (
                        :CDFORNECED,
                        :CDPRODUTO,
                        :IDTPFORPGPRF,
                        :QTDIASENTR,
                        :QTMINAF,
                        :IDCOTAOBRIG,
                        :SGUNIDADE,
                        :NRPARCPGTPRF,
                        :NRDIAPGFIPRF,
                        :CDFORMPGTO,
                        :IDUTDIAPGPRF,
                        :NRORG
                    )";
                    
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function insertParcelas ($data, $row)
    {
        $param = array();
        $param['CDFORNECED']    = $row['CDFORNECED'];
        $param['CDPRODUTO']     = $row['CDPRODUTO'];
        $param['NRDIASPGPRFO']  = $data['NRDIASPGTOFO'];
        $param['VRPERCPGPRFO']  = $data['VRPERCPGTOFO'];
        $param['NRORG']         = $row['NRORG'];
        
        $query = "  INSERT INTO PZOPGTPRFO
                      (CDFORNECED, CDPRODUTO, NRDIASPGPRFO, VRPERCPGPRFO, NRORG)
                    VALUES
                      (:CDFORNECED, :CDPRODUTO, :NRDIASPGPRFO, :VRPERCPGPRFO, :NRORG)";
                      
        try {
             $std = $this->connection->prepare($query);
             $std->execute($param);
        } catch (Exception $e) {
             throw $e;
        }
    }
     
    public function insertLista ($nrlista, $cdforneced, $nrorg)
    {
        $param = array();
        $param['NRLISTA'] = $nrlista;
        $param['CDLISTA'] = $cdforneced;
        $param['NRORG']   = $nrorg;
        
        $query = "  INSERT INTO LISTA (NRLISTA, CDLISTA, NRORG) VALUES (:NRLISTA, :CDLISTA, :NRORG)";
        
        try {
             $std = $this->connection->prepare($query);
             $std->execute($param);
        } catch (Exception $e) {
             throw $e;
        }
    }
     
    public function insertProdForn ($row)
    {
        $param = array();
        $param['P_CDFORNECED']    = $row['CDFORNECED'];
        $param['P_CDPRODUTO']     = $row['CDPRODUTO'];
        $param['P_NRORG']         = $row['NRORG'];
        
        $query =    "INSERT INTO PRODFORN
                       (CDFORNECED, CDPRODUTO, NRORG)
                    VALUES
                       (:P_CDFORNECED, :P_CDPRODUTO, :P_NRORG)";
                       
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function insertPrazoPgt ($row, $CDFORNECEDORIG)
    {
        $param = array();
        $param['P_CDFORNECED'] = $row['CDFORNECED'];
        $param['P_CDFORNORG']  = $CDFORNECEDORIG;
        $param['P_CDPRODUTO']  = $row['CDPRODUTO'];
        
        $query =    "INSERT INTO PZOPGTPRFO 
                    (
                        CDFORNECED,
                        CDPRODUTO,
                        NRDIASPGPRFO,
                        VRPERCPGPRFO,
                        NRORG
                    )
                        SELECT
                            :P_CDFORNECED,
                            PZOPGTPRFO.CDPRODUTO,
                            PZOPGTPRFO.NRDIASPGPRFO,
                            PZOPGTPRFO.VRPERCPGPRFO,
                            PZOPGTPRFO.NRORG
                        FROM
                            PZOPGTPRFO
                        WHERE
                            PZOPGTPRFO.CDFORNECED =:P_CDFORNORG
                            AND   PZOPGTPRFO.CDPRODUTO =:P_CDPRODUTO";
                            
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    /********************
     *      UPDATES     *
     ********************/
     
    public function updateParcelas ($data, $row, $prazo)
    {
        $param = array();
        $param['VRPERCPGPRFO']      = $data['VRPERCPGTOFO'];
        $param['NRDIASPGPRFO']      = $data['NRDIASPGTOFO'];
        $param['OLD_CDFORNECED']    = $row['CDFORNECED'];
        $param['OLD_CDPRODUTO']     = $row['CDPRODUTO'];
        $param['OLD_NRDIASPGPRFO']  = $prazo['NRDIASPGPRFO'];  
      
        $query = "  UPDATE 
                        PZOPGTPRFO
                    SET
                        VRPERCPGPRFO = :VRPERCPGPRFO,
                        NRDIASPGPRFO = :NRDIASPGPRFO
                    WHERE
                        CDFORNECED   = :OLD_CDFORNECED AND
                        CDPRODUTO    = :OLD_CDPRODUTO AND
                        NRDIASPGPRFO = :OLD_NRDIASPGPRFO";
                        
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function updateProdForn ($row)
    {
        $param = array();
        $param['IDTPFORPGPRF']   = $row['IDTPFORPGTFO'];
        $param['QTDIASENTR']     = self::parseFloat($row['QTDIASENTR']);
        $param['QTMINAF']        = self::parseFloat($row['QTMINAF']);
        $param['IDCOTAOBRIG']    = 'N';
        $param['SGUNIDADE']      = $row['SGUNIDADE'];
        $param['NRPARCPGTPRF']   = $row['NRPARCPGTOFO'];
        $param['NRDIAPGFIPRF']   = $row['NRDIAPGFIXFO'];
        $param['CDFORMPGTO']     = $row['CDFORMPGTO'];
        $param['IDUTDIAPGPRF']   = $row['IDUTDIAPGTFO'];
        $param['OLD_CDFORNECED'] = $row['CDFORNECED'];
        $param['OLD_CDPRODUTO']  = $row['CDPRODUTO'];
        
        $query = "  UPDATE 
                        PRODFORN
                    SET
                        IDTPFORPGPRF = :IDTPFORPGPRF,
                        QTDIASENTR   = :QTDIASENTR,
                        QTMINAF      = :QTMINAF,
                        IDCOTAOBRIG  = :IDCOTAOBRIG,
                        SGUNIDADE    = :SGUNIDADE,
                        NRPARCPGTPRF = :NRPARCPGTPRF,
                        NRDIAPGFIPRF = :NRDIAPGFIPRF,
                        CDFORMPGTO   = :CDFORMPGTO,
                        IDUTDIAPGPRF = :IDUTDIAPGPRF
                    WHERE
                        CDFORNECED   = :OLD_CDFORNECED AND
                        CDPRODUTO    = :OLD_CDPRODUTO";
                        
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function updateProdFornComp ($row)
    {
        $param = array();
        $param['VRARREDCMPFO']    = self::parseFloat($row['VRARREDCMPFO']);
        $param['CDEXPRODFORN']    = $row['CDEXPRODFORN'];
        $param['VRPERPIPRFO']     = self::parseFloat($row['VRPERPIPRFO']);
        $param['VRARREDEMPE']     = self::parseFloat($row['VRARREDEMPE']);
        $param['VRPERVARPREPRFO'] = self::parseFloat($row['VRPERVARPREPRFO']);
        $param['NRDIASVALPRFORN'] = self::parseFloat($row['NRDIASVALPRFORN']);
        $param['CDFORNECED']      = $row['CDFORNECED'];
        $param['CDPRODUTO']       = $row['CDPRODUTO'];
        $param['CDPRODCOMPL']     = $row['CDPRODCOMPL'];
        
        $query = "  UPDATE 
                        PRODFORNCOMP
                    SET
                        VRARREDCMPFO    = :VRARREDCMPFO,
                        VRPERPIPRFO     = :VRPERPIPRFO,
                        CDEXPRODFORN    = :CDEXPRODFORN,
                        VRARREDEMPE     = :VRARREDEMPE,
                        VRPERVARPREPRFO = :VRPERVARPREPRFO,
                        NRDIASVALPRFORN = :NRDIASVALPRFORN
                    WHERE
                        CDFORNECED      = :CDFORNECED AND
                        CDPRODUTO       = :CDPRODUTO AND
                        CDPRODCOMPL     = :CDPRODCOMPL";
                        
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function updateAlteraAuto ($row)
    {
        $param = array();
        $param['CDFORNECED']     = $row['CDFORNECED'];
        $param['CDPRODINI']      = $row['CDARVPRODINI'];
        $param['CDPRODFIN']      = $row['CDARVPRODFIN'];
        $param['CDPRODUTO']      = $row['CDPRODUTO'];
        $param['PI']             = self::parseFloat($row['PIDSV']);
        $param['EMPENHO']        = self::parseFloat($row['EMPENHO']);
        $param['VARIAMAXIMO']    = self::parseFloat($row['VARIAMAXIMO']);
        $param['VALIDADEDIAS']   = self::parseFloat($row['VALIDADEDIAS']);
        $param['ARREDONDAMENTO'] = self::parseFloat($row['VRARREDCMPFO']);
        $query = "  UPDATE 
                        PRODFORNCOMP
                    SET
                        VRARREDCMPFO    = DECODE(:ARREDONDAMENTO, 0, VRARREDCMPFO, :ARREDONDAMENTO),
                        VRPERPIPRFO     = DECODE(:PI, 0, VRPERPIPRFO, :PI),
                        VRARREDEMPE     = DECODE(:EMPENHO, 0, VRARREDEMPE, :EMPENHO),
                        VRPERVARPREPRFO = DECODE(:VARIAMAXIMO, 0, VRPERVARPREPRFO, :VARIAMAXIMO),
                        NRDIASVALPRFORN = DECODE(:VALIDADEDIAS, 0, NRDIASVALPRFORN, :VALIDADEDIAS)
                    WHERE 
                        CDFORNECED = :CDFORNECED AND 
                        ((CDPRODCOMPL BETWEEN :CDPRODINI AND :CDPRODFIN) AND 
                        (:CDPRODUTO = 'T') OR (INSTR(:CDPRODUTO, CDPRODCOMPL) > 0))";
                            
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function updateVerifiedProdForn ($row, $CDFORNECEDORIG)
    {
        $param = array();
        $param['P_CDFORNORG']  = $CDFORNECEDORIG;
        $param['P_CDPRODUTO']  = $row['CDPRODUTO'];
        $param['P_CDFORNECED'] = $row['CDFORNECED'];
        
        $query = "  UPDATE 
                        PRODFORN
                    SET
                   (    
                        PRODFORN.CDFORMPGTO,
                        PRODFORN.IDTPFORPGPRF,
                        PRODFORN.NRPARCPGTPRF,
                        PRODFORN.NRDIAPGFIPRF,
                        PRODFORN.IDUTDIAPGPRF,
                        PRODFORN.QTMINAF,
                        PRODFORN.SGUNIDADE,
                        PRODFORN.QTDIASENTR
                    ) = 
                        (
                            SELECT
                                P.CDFORMPGTO,
                                P.IDTPFORPGPRF,
                                P.NRPARCPGTPRF,
                                P.NRDIAPGFIPRF,
                                P.IDUTDIAPGPRF,
                                P.QTMINAF,
                                P.SGUNIDADE,
                                P.QTDIASENTR
                            FROM
                                PRODFORN P
                            WHERE
                                P.CDFORNECED = :P_CDFORNORG AND
                                P.CDPRODUTO  = :P_CDPRODUTO
                        )
                    WHERE
                       :P_CDFORNECED = PRODFORN.CDFORNECED AND
                       :P_CDPRODUTO  = PRODFORN.CDPRODUTO";
                       
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    /********************
     *      DELETES     *
     ********************/
     
    public function deleteProdForn ($row)
    {
        $param = array();
        $param['OLD_CDFORNECED'] = $row['CDFORNECED'];
        $param['OLD_CDPRODUTO']  = $row['CDPRODUTO'];
        
        $query = "  DELETE FROM 
                        PRODFORN
                    WHERE
                      CDFORNECED = :OLD_CDFORNECED AND
                      CDPRODUTO = :OLD_CDPRODUTO";
                      
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e) {
            throw $e;
        }
    } 
     
    public function deleteQProdForn ($row)
    {
        $param = array();
        $param['P_CDPRODUTO']  = $row['CDPRODUTO'];
        $param['P_CDFORNECED'] = $row['CDFORNECED'];

        $query = "  DELETE 
                        QFOPRODFORN
                    WHERE
                        CDFORNECED = :P_CDFORNECED AND
                        (
                            SELECT
                                CDARVPROD
                            FROM 
                                PRODUTO
                            WHERE 
                                PRODUTO.CDPRODUTO = QFOPRODFORN.CDPRODUTO
                        )  
                    LIKE 
                        :P_CDPRODUTO || '%'";
                    
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function deleteProdFornTodos ($codLista)
    {
        $param = array();
        $param['P_CDFORNECED'] = $codLista;
        
        $query = "  DELETE FROM 
                        PRODFORN
                    WHERE
                        EXISTS 
                        (
                            SELECT 
                                1
                            FROM 
                                LISTA
                            WHERE 
                                LISTA.CDLISTA  = CDFORNECED AND
                                LISTA.NRLISTA  = :P_CDFORNECED
                        )";
                               
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function deleteFormPag ($row)
    {
        $params = array();
        $params['P_CDFORNECED'] = $row[0]['CDFORNECED'];
        $params['P_CDPRODUTO'] = $row[0]['CDPRODUTO'];
        $params['P_NRDIASPGPRFO'] = $row[0]['NRDIASPGTOFO'];
        $params['P_VRPERCPGPRFO'] = $row[0]['VRPERCPGTOFO'];
        $params['P_NRORG'] = $row[0]['NRORG'];
       
        $query = "  DELETE FROM 
                        PZOPGTPRFO
                    WHERE
                        CDFORNECED =:P_CDFORNECED
                        AND  CDPRODUTO =:P_CDPRODUTO 
                        AND  NRDIASPGPRFO =:P_NRDIASPGPRFO
                        AND  VRPERCPGPRFO =:P_VRPERCPGPRFO
                        AND  NRORG = :P_NRORG";
                        
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function deleteExpProdForn ($codLista, $prodIni, $prodFin)
    {
        $param = array();
        $param['P_CDFORNECED'] = $codLista;
        $param['P_PRODINI'] = $prodIni;
        $param['P_PRODFIN'] = $prodFin;
        
        $query = "  DELETE FROM 
                        PRODFORN
                    WHERE 
                        EXISTS 
                        (
                            SELECT 
                                1
                            FROM 
                                LISTA
                            WHERE 
                                LISTA.CDLISTA = PRODFORN.CDFORNECED AND
                                LISTA.NRLISTA = :P_CDFORNECED
                        ) AND
                        EXISTS 
                        (
                            SELECT 
                                1
                            FROM 
                                PRODUTO
                            WHERE 
                                PRODUTO.CDPRODUTO = PRODFORN.CDPRODUTO AND 
                                PRODUTO.CDARVPROD BETWEEN :P_PRODINI AND :P_PRODFIN
                        )";
                                                
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function deleteLista ($nrlista)
    {
        $param = array();
        $param['P_NRLISTA'] = $nrlista;
        
        $query = "  DELETE FROM
                      LISTA
                    WHERE
                      NRLISTA = :P_NRLISTA";
                      
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function deletePrazos ($row)
    {
        $param = array();
        $param['P_CDFORNECED'] = $row['CDFORNECED'];
        $param['P_CDPRODUTO']  = $row['CDPRODUTO'];
        
        $query = "  DELETE FROM
                       PZOPGTPRFO
                    WHERE
                       CDFORNECED = :P_CDFORNECED AND
                       CDPRODUTO  = :P_CDPRODUTO";
                       
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    /********************
     *      SELECTS     *
     ********************/

    public function findProduto($row) 
    {
        $param = array();
        $param['P_CDFORNECED'] = $row['CDFORNECED'];
        $param['P_CDPRODUTO']  = $row['CDPRODUTO'];
        $param['P_NRORG']      = $row['NRORG'];
        
        $query = "  SELECT
                       CDFORNECED,
                       CDPRODUTO,
                       NRORG
                    FROM
                       PRODFORN
                    WHERE
                       CDFORNECED = :P_CDFORNECED AND
                       CDPRODUTO  = :P_CDPRODUTO AND
                       NRORG      = :P_NRORG";
                       
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            return $std->fetchAll();
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function validateProduto($row) 
    {
        $param = array();
        $param['P_CDFORNECED'] = $row['CDFORNECED'];
        $param['P_CDARVPROD']  = $row['CDARVPROD'];
        $param['P_NRORG']      = $row['NRORG'];
        
        $query = "  SELECT
                       PRODFORN.CDPRODUTO
                    FROM
                       PRODFORN,
                       PRODUTO
                    WHERE
                       PRODFORN.CDPRODUTO = PRODUTO.CDPRODUTO AND
                       PRODFORN.CDFORNECED = :P_CDFORNECED AND
                       PRODFORN.NRORG = PRODUTO.NRORG AND
                       PRODUTO.NRORG = :P_NRORG AND
                       ((PRODUTO.CDARVPROD LIKE :P_CDARVPROD || '%') OR (INSTR(:P_CDARVPROD, PRODUTO.CDARVPROD) = 1))";
                        
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            return $std->fetchAll();
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function verifyPrazos($row)
    {
        $param = array();
        $param['P_CDFORNECED'] = $row['CDFORNECED'];
        $param['P_CDPRODUTO']  = $row['CDPRODUTO'];
        
        $query = "  SELECT
                      CDFORNECED,
                      CDPRODUTO,
                      NRDIASPGPRFO,
                      VRPERCPGPRFO,
                      NRORG
                    FROM
                      PZOPGTPRFO
                    WHERE
                      CDFORNECED = :P_CDFORNECED AND
                      CDPRODUTO = :P_CDPRODUTO
                    ORDER BY
                      NRDIASPGPRFO";
                      
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            return $std->fetchAll();
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function getCodProd($row, $CDFORNECEDDEST) 
    {
        $param = array();
        $param['P_CDFORNORG'] = $row['CDFORNECEDORIG'];
        $param['P_NRORG']     = $row['NRORG'];
        $param['P_CDPRODINI'] = $row['CDARVPRODINI'];
        $param['P_CDPRODFIN'] = $row['CDARVPRODFIN'];
        $param['P_CDFORNDES'] = $CDFORNECEDDEST;
        
        $query = "  SELECT
                        FORNECEDOR.CDFORNECED,
                        PRODFORN.CDPRODUTO,
                        PRODUTO.CDARVPROD,
                        FORNECEDOR.NRORG
                    FROM
                        PRODUTO,
                        PRODFORN,
                        FORNECEDOR
                    WHERE
                        PRODFORN.CDFORNECED     = :P_CDFORNORG AND 
                        PRODUTO.NRORG           = PRODFORN.NRORG AND 
                        PRODFORN.NRORG          = FORNECEDOR.NRORG AND
                        FORNECEDOR.NRORG        = :P_NRORG AND
                        PRODUTO.CDARVPROD BETWEEN :P_CDPRODINI AND :P_CDPRODFIN AND
                        PRODUTO.CDPRODUTO       = PRODFORN.CDPRODUTO AND
                        (
                            INSTR(:P_CDFORNDES,FORNECEDOR.CDFORNECED) <> 0 OR :P_CDFORNDES = 'T'
                        ) AND 
                        NOT EXISTS 
                        (
                            SELECT
                                A.CDPRODUTO
                            FROM
                                PRODFORN A,
                                PRODUTO PROD
                            WHERE
                                A.CDPRODUTO = PROD.CDPRODUTO AND
                                A.CDFORNECED = FORNECEDOR.CDFORNECED AND
                                (
                                    PROD.CDARVPROD LIKE PRODUTO.CDARVPROD || '%' OR PRODUTO.CDARVPROD LIKE PROD.CDARVPROD || '%'
                                )
                        )";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function verifyDupProdForn($row) 
    {
        $param = array();
        $param['P_CDFORNECED'] = $row['CDFORNECED'];
        $param['P_CDPRODUTO']  = $row['CDPRODUTO'];
        $query = "  SELECT 
                        CDFORNECED, CDPRODUTO
                    FROM 
                        PRODFORN
                    WHERE 
                        CDFORNECED = :P_CDFORNECED AND
                        CDPRODUTO  = :P_CDPRODUTO";
                        
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            return $std->fetchAll();
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function verifyProdForn($row)
    {
        $param = array();
        $param['P_CDFORNECED'] = $row['CDFORNECED'];
        $param['P_CDARVINI'] = $row['CDARVPRODINI'];
        $param['P_CDARVFIN'] = $row['CDARVPRODFIN'];
        $param['P_NRORG'] = $row['NRORG'];
        
        $query = "SELECT COUNT(*)
                  FROM PRODFORNCOMP, PRODUTO
                  WHERE PRODFORNCOMP.CDFORNECED = :P_CDFORNECED
                  AND PRODFORNCOMP.CDPRODCOMPL = PRODUTO.CDPRODUTO
                  AND PRODUTO.CDARVPROD BETWEEN :P_CDARVINI AND :P_CDARVFIN
                  AND PRODFORNCOMP.NRORG = PRODUTO.NRORG
                  AND PRODFORNCOMP.NRORG = :P_NRORG";
    
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            return $std->fetchAll();
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function getProdCad($row, $fornecedor) 
    {
        $param = array();
        $param['P_CDFORNECED']   = $fornecedor;
        $param['P_CDPRODUTOINI'] = $row['CDARVPRODINI'];
        $param['P_CDPRODUTOFIN'] = $row['CDARVPRODFIN'];
        
        $query = "  SELECT
                        PRODUTO.CDPRODUTO,
                        PRODUTO.CDARVPROD,
                        PRODUTO.NRORG
                    FROM
                        PRODUTO
                    WHERE
                        PRODUTO.CDARVPROD BETWEEN :P_CDPRODUTOINI AND :P_CDPRODUTOFIN AND
                        PRODUTO.CDPRODESTO IS NOT NULL AND
                        NOT EXISTS
                        ( 
                            SELECT
                                PRODFORN.CDPRODUTO
                            FROM
                                PRODFORN, PRODUTO P
                            WHERE
                                P.CDPRODUTO = PRODFORN.CDPRODUTO AND
                                PRODFORN.CDFORNECED = :P_CDFORNECED AND
                                PRODUTO.CDARVPROD  LIKE P.CDARVPROD || '%'
                       )";
                       
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            return $std->fetchAll();
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    /***********************
     *      PROCEDURES     *
     ***********************/
     
    public function procInsertProduto($row)
    {
        $connection = $this->connection;
        $procedure = new StoredProcedure($connection, 'INSERE_PRODFORNCMP_MARCFORNCMP');
        $procedure->addParam(new Param('P_CDFORNECED',  Param::PARAM_INPUT, $row['CDFORNECED'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDMARCA',     Param::PARAM_INPUT, $row['CDMARCA'],    Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDPRODUTO',   Param::PARAM_INPUT, $row['CDPRODUTO'],  Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDARVPROD',   Param::PARAM_INPUT, $row['CDARVPROD'],  Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_ARRED',       Param::PARAM_INPUT, $row['ARRED'],      Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDFORNORIG',  Param::PARAM_INPUT, $row['CDFORNORIG'], Param::PARAM_TYPE_STR));
        $rowsaffect = $procedure->execute();
    }
}